UPDATE OBJECT_VALUES
SET VALUE = '0'
Where object in (select link from s_objects where code in ('PROJECT', 'WF_PROJECT'))
  and property in (select link from s_property where code in ('VERSION', 'VERSION_MAJOR', 'VERSION_MINOR', 'VERSION_RELEASE', 'VERSION_FIX'))
GO
IF NOT EXISTS(select * from user_task WHERE SID = USER_SID() )
	INSERT INTO user_task (SID, LINK_TASK)
	SELECT  USER_SID(), LINK FROM S_OBJECTS WHERE CODE = 'SMETA'
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[tmp_dates2]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [tmp_dates2]
GO
EXECUTE dbo.X_CHANGE_USER_TASK 'SMETA'
GO
select * into tmp_dates2 from admin_info
GO
Declare @kassa int, @BB datetime, @BE datetime
Select @kassa = LINK from S_OBJECTS Where CODE = 'SMETA'
SELECT @BB = convert(datetime, '19000101', 112), @BE = convert(datetime, '21100101', 112)
EXECUTE I_SET_ADMIN_DATE @kassa, @BB, @BB, @BE
GO




EXECUTE VX_UPGRADE_CLEAR
GO

CREATE TABLE [S_FILES_U] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (254)  NOT NULL ,
	[Release] [int] NOT NULL ,
	[Path] [varchar] (254)  NOT NULL ,
	[CreateDate] [datetime] NOT NULL ,
	[FileSize] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [S_OBJECTS_U] (
	[LINK] [int] IDENTITY (1, 1) NOT NULL ,
	[CODE] [char] (30)  NOT NULL ,
	[NAME] [varchar] (254)  NOT NULL ,
	[ORDERS] [smallint] NOT NULL ,
	[LINK_SELF] [int] NULL ,
	[LINK_CLASS] [int] NULL ,
	[Managed] [bit] NOT NULL ,
	[Inherited] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [S_RELEASE_U] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Project] [int] NOT NULL ,
	[Release] [int] NOT NULL ,
	[Fix] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [s_fileparts_U] (
	[file_id] [int] NOT NULL ,
	[orders] [int] NOT NULL ,
	[body] [varbinary] (8000) NULL 
) ON [PRIMARY]
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[HISTORY_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[HISTORY_U]
GO

CREATE TABLE [dbo].[HISTORY_U] (
	[LINK] [int] IDENTITY (1, 1) NOT NULL ,
	[LINK_UP] [int] NOT NULL ,
	[TASK_CODE] [varchar] (10) NOT NULL ,
	[INFO] [varchar] (8000) NOT NULL 
) ON [PRIMARY]
GO




if exists (select * from dbo.sysobjects where id = object_id(N'[FAQ_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [FAQ_U]
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FAQ_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [FAQ_U] (
	[LINK] [int] IDENTITY (1, 1) NOT NULL ,
	[TASK] [varchar] (20)  NOT NULL ,
	[GRP] [varchar] (100)  NOT NULL ,
	[ORDERS] [int] NOT NULL ,
	[QUEST] [varchar] (250)  NOT NULL ,
	[ANSWER] [varchar] (7000)  NOT NULL
) ON [PRIMARY]
END

GO





if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VX_UPGRADE_CLEAR]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[VX_UPGRADE_CLEAR]
GO


CREATE       PROCEDURE VX_UPGRADE_CLEAR
AS
if exists (select * from dbo.sysobjects where id = object_id(N'[object_values_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table object_values_u
if exists (select * from dbo.sysobjects where id = object_id(N'[object_values]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('object_values')

if exists (select * from dbo.sysobjects where id = object_id(N'[object_var_values_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table object_var_values_u
if exists (select * from dbo.sysobjects where id = object_id(N'[object_var_values]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('object_var_values')

if exists (select * from dbo.sysobjects where id = object_id(N'[object_property_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table object_property_u
if exists (select * from dbo.sysobjects where id = object_id(N'[object_property]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('object_property')

if exists (select * from dbo.sysobjects where id = object_id(N'[s_navigator_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_navigator_u
if exists(select * from syscolumns sc where name = 'old_link' and id = OBJECT_ID('s_navigator'))
begin
	drop index s_navigator.tmp_index_for_old_link
	alter table s_navigator
		drop column old_link
end
if exists (select * from dbo.sysindexes where name = N'IX_S_NAVIGATOR' and id = object_id(N'[dbo].[S_NAVIGATOR]'))
drop index [dbo].[S_NAVIGATOR].[IX_S_NAVIGATOR]

if exists (select * from dbo.sysobjects where id = object_id(N'[s_navigator]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_navigator')

if exists (select * from dbo.sysobjects where id = object_id(N'[object_var_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table object_var_u
if exists (select * from dbo.sysobjects where id = object_id(N'[object_var]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('object_var')

if exists (select * from dbo.sysobjects where id = object_id(N'[s_property_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_property_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_property]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_property')

if exists (select * from sysobjects where id = OBJECT_ID(N's_permissions_u') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_permissions_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_permissions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_permissions')

if exists (select * from sysobjects where id = OBJECT_ID(N's_dbobjects_u') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_dbobjects_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_dbobjects]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_dbobjects')

if exists (select * from sysobjects where id = OBJECT_ID(N's_tables_u') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_tables_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_tables]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_tables')

if exists (select * from sysobjects where id = OBJECT_ID(N's_release_u') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_release_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_release]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_release')

if exists (select * from dbo.sysobjects where id = object_id(N'[s_objects_u]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table s_objects_u
if exists (select * from dbo.sysobjects where id = object_id(N'[s_objects]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DBCC DBREINDEX ('s_objects')

if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_FORMS_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_FORMS_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_TABLES_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_TABLES_U

if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_ROWS_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_ROWS_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_COLOUMNS_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_COLOUMNS_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_FORMULA_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_FORMULA_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_CONDITIONS_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_CONDITIONS_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_COND_VALUE_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_COND_VALUE_U
if exists (select * from sysobjects where id = OBJECT_ID(N'REPORT_CONTROL_PARITIES_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table REPORT_CONTROL_PARITIES_U
if exists (select * from sysobjects where id = OBJECT_ID(N'S_FILES_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table S_FILES_U
if exists (select * from sysobjects where id = OBJECT_ID(N'S_HISTORY_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table S_HISTORY_U
if exists (select * from sysobjects where id = OBJECT_ID(N'S_FILEPARTS_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table S_FILEPARTS_U
if exists (select * from sysobjects where id = OBJECT_ID(N'DICTION_U') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table DICTION_U
if exists (select * from dbo.sysobjects where id = object_id(N'[REPORT_OPTIONS_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [REPORT_OPTIONS_U]
if exists (select * from dbo.sysobjects where id = object_id(N'[REPORT_CONTROL_ROWS_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [REPORT_CONTROL_ROWS_U]
if exists (select * from dbo.sysobjects where id = object_id(N'[REPORT_CONTROL_RULES_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [REPORT_CONTROL_RULES_U]

if exists (select * from dbo.sysobjects where id = object_id(N'u_obj') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [u_obj]

if exists (select * from dbo.sysobjects where id = object_id(N'u_prop') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [u_prop]


if exists (select * from dbo.sysobjects where id = object_id(N'[EXPORT_FIELDS_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [EXPORT_FIELDS_U]

if exists (select * from dbo.sysobjects where id = object_id(N'[EXPORT_BLOCKS_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [EXPORT_BLOCKS_U]

if exists (select * from dbo.sysobjects where id = object_id(N'[EXPORT_MODELS_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	drop table [EXPORT_MODELS_U]


if exists (select * from dbo.sysobjects where id = object_id(N'[S_BANK_FORMAT_BASE_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [S_BANK_FORMAT_BASE_U]

if exists (select * from dbo.sysobjects where id = object_id(N'[S_GROUP_SID_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [S_GROUP_SID_U]

if exists (select * from dbo.sysobjects where id = object_id(N'[DICTION_APP_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)   
	drop table [dbo].[DICTION_APP_U]  

if exists (select * from dbo.sysobjects where id = object_id(N'[OBJECT_VAR_U_DELETE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [OBJECT_VAR_U_DELETE]

if exists (select * from dbo.sysobjects where id = object_id(N'[ECONOMY_OPER_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [ECONOMY_OPER_U]

/*if exists (select * from dbo.sysobjects where id = object_id(N'[XOZ_OPER_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [XOZ_OPER_U]*/

if exists (select * from dbo.sysobjects where id = object_id(N'[JOURNAL_OPERATION_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [JOURNAL_OPERATION_U]


if exists (select * from dbo.sysobjects where id = object_id(N'[HISTORY_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [HISTORY_U]

if exists (select * from dbo.sysobjects where id = object_id(N'[FAQ_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [FAQ_U]



GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[VX_UPGRADE_S_RELEASE]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[VX_UPGRADE_S_RELEASE]
GO

/*
  (Keysystems), 2005
*/

CREATE  PROCEDURE VX_UPGRADE_S_RELEASE
AS

SELECT SO.LINK as Project, SR.Release, SR.Fix
INTO #tmpRelease
FROM S_RELEASE_U SR, S_OBJECTS_U SOU, S_OBJECTS SO
WHERE Project = SOU.LINK AND RTRIM(LTRIM(SO.CODE))=RTRIM(LTRIM(SOU.CODE))
	and not exists(Select Release From S_Release Where Release = SR.Release and Project = SO.LINK AND Fix = SR.Fix)

BEGIN TRAN
	INSERT INTO S_RELEASE(Project, Release, Fix)
	SELECT Project, Release, Fix
	FROM #tmpRelease
	
	
	Select SFU.Name, SR.ID as Release, SFU.Path, SFU.CreateDate, SFU.FileSize, SFU.ID as oldID
	INTO #tmpFiles
	From S_FILES_U SFU INNER JOIN S_RELEASE_U SUR ON SFU.Release = SUR.ID
		INNER JOIN S_RELEASE SR ON SUR.Release = SR.Release AND SUR.Fix = SR.Fix
		INNER JOIN #tmpRelease TR ON SR.Release = TR.Release
			AND SR.Project = TR.Project AND SR.Fix = TR.Fix
	
	
	DELETE FROM S_FILES
	FROM #tmpFiles T WHERE T.NAME = S_FILES.NAME
	
	
	INSERT INTO S_FILES(Name, Release, Path, CreateDate, FileSize)
	SELECT Name, Release, Path, CreateDate, FileSize
	From #tmpFiles
	
	
	INSERT INTO S_FILEPARTS(File_ID, ORDERS, BODY)
	Select SF.ID, SPU.Orders, convert(varchar(8000), SPU.Body)
	From S_FILES SF, S_FILEPARTS_U SPU, #tmpFiles TF
	Where SF.Release = TF.Release
		AND SF.Name = TF.Name
		AND SPU.File_ID = TF.oldID

	/* HISTORY */
	DELETE FROM dbo.HISTORY
	
	INSERT INTO dbo.HISTORY(LINK_UP, TASK_CODE, INFO)
	SELECT NEW.ID, HU.TASK_CODE, HU.INFO FROM dbo.HISTORY_U HU INNER JOIN dbo.S_RELEASE_U OLD ON HU.LINK_UP = OLD.ID
	INNER JOIN dbo.S_RELEASE NEW ON OLD.RELEASE = NEW.RELEASE AND OLD.FIX = NEW.FIX
	--- HISTORY


	/* FAQ */
	DELETE FROM dbo.FAQ
	
	INSERT INTO dbo.FAQ (TASK,GRP,ORDERS,QUEST,ANSWER)
	SELECT TASK,GRP,ORDERS,QUEST,ANSWER FROM dbo.FAQ_U
	--- FAQ

	IF EXISTS(select * from s_files F
		where F.Filesize <> (select sum(datalength(body)) from s_fileparts where file_id = F.id))
	BEGIN 
		ROLLBACK
		raiserror('     !   !',11,1)
		RETURN
	END
WHILE @@TRANCOUNT > 0
	COMMIT TRAN

Drop Table #tmpFiles
Drop Table #tmpRelease



GO

	WHILE @@TRANCOUNT > 0
	raiserror('@@TRANCOUNT>0!!!',11,1)
GO



IF not exists(select * from sysobjects where id = object_id('[dbo].[OKPD_U]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[OKPD_U] (
	[LINK] int,
	[LINK_SELF] int,
	[CODE] char(12),
	[NAME] varchar(254),
	[UM] int,
	[USED] bit)
GO
